
#include <cstdlib>   /* std::atoi, EXIT_FAILURE, EXIT_SUCCESS */
#include <cassert>   /* assert */
#include <iostream>  /* std::cout */

#include "BigIntegerUtils.hh" /* bigIntegerToString */
#include "factorial.h"        /* factorial */

int main(int argc, const char *argv[])
{
    if (argc != 2) {
        std::cerr << "Usage " << argv[0]  << " [N]" << std::endl;
        return EXIT_FAILURE;
    }
    assert(std::atoi(argv[1])>=0);
    const unsigned int N = static_cast<unsigned int>(std::atoi(argv[1]));

    std::cout << "The value of factorial(" << N << ") is " 
              << factorial(N) << '.' << std::endl
              << "The value of factorial_big_int(" << N << ") is " 
              << bigIntegerToString(factorial_bigint(N)) << '.' << std::endl;
    
    return EXIT_SUCCESS;
}
