
#ifndef UTILS_H
#define UTILS_H

#include "collection.h"
#include "factorial.h"

/* question 2 */
void init(MyCollection<int>& c, unsigned int k);
void apply_fact(const MyCollection<int> &c, MyCollection<int>& res);

/* question 3 */
void apply_fact(const MyCollection<int> &c, MyCollection<BigInteger>& res);

/* question 4 -- generic std::vector implementation */
template <typename T>
void apply_fact(const MyCollection<int> &c, std::vector<T>& res) {
    assert (res.size() == 0);
    for (unsigned int i=0; i<c.current_size(); i++) {
        res.push_back(factorial_generic<T>(c.get_elem(i)));
    }
}

#endif /* end of include guard: UTILS_H */
