
#include <cstdlib>   /* EXIT_FAILURE, EXIT_SUCCESS */
#include <ctime>     /* std::time */

#include "utils.h"

int main(int argc, const char *argv[])
{
    /* initialize random seed */
    std::srand(std::time(nullptr));
    
    const unsigned int N = 4;
    MyCollection<int> c0(N), c1(N);
    MyCollection<BigInteger> c2(N);

    std::vector<short>      c3;
    std::vector<int>        c4;
    std::vector<long>       c5;
    std::vector<BigInteger> c6;

    init(c0, c0.max_size());

    apply_fact(c0, c1);
    apply_fact(c0, c2);
    apply_fact(c0, c3);
    apply_fact(c0, c4);
    apply_fact(c0, c5);
    apply_fact(c0, c6);

    std::cout << "------------------------------------------------------" << std::endl;
    std::cout << "Initialization:                   " << c0 << std::endl;
    std::cout << "------------------------------------------------------" << std::endl;
    std::cout << "factorial_int     (MyCollection): " << c1 << std::endl;
    std::cout << "factorial_bigint  (MyCollection): " << c2 << std::endl;
    std::cout << "------------------------------------------------------" << std::endl;
    std::cout << "factorial_short:  (std::vector):  " << c3 << std::endl;
    std::cout << "factorial_int:    (std::vector):  " << c4 << std::endl;
    std::cout << "factorial_long:   (std::vector):  " << c5 << std::endl;
    std::cout << "factorial_bigint: (std::vector):  " << c6 << std::endl;
    std::cout << "------------------------------------------------------" << std::endl;


    return EXIT_SUCCESS;
}
