
#include <cstdlib> /* std::rand */
#include "utils.h"

void init(MyCollection<int>& c, unsigned int k) {
    assert(c.current_size()+k<=c.max_size());
    for (unsigned int i=0; i<k; i++) {
        c.insert_elem(std::rand() % 20);
    }
}

void apply_fact(const MyCollection<int> &c, MyCollection<int>& res) {
    assert (res.current_size() == 0);
    assert (res.max_size() >= c.current_size());
    for (unsigned int i=0; i<c.current_size(); i++) {
        res.insert_elem(factorial(c.get_elem(i)));
    }
}

void apply_fact(const MyCollection<int> &c, MyCollection<BigInteger>& res) {
    assert (res.current_size() == 0);
    assert (res.max_size() >= c.current_size());
    for (unsigned int i=0; i<c.current_size(); i++) {
        res.insert_elem(factorial_bigint(c.get_elem(i)));
    }
}
