
/* Always guard a header with an include guard.      *
 * See: https://en.wikipedia.org/wiki/Include_guard  */
#ifndef DATE_H
#define DATE_H

#include <ctime> 

class Date {
    public:
        Date(int day, int month, int year);
        Date(std::time_t date);

        void print_date();
        void happy_birthday(const char *n, Date b);

        int duration(const Date& d) const;
    
        /* Accessors */
        int day() const;
        int month() const;
        int year() const;

    private:
        int m_day, m_month, m_year;
        
        bool operator<(const Date& other) const;
        int  operator-(const Date& other) const;
};

#endif /* end of include guard: DATE_H */
